
package LFA2;

import weka.core.*;
import weka.classifiers.Classifier;
import java.io.*;
import java.util.*;

public abstract class LFAClassifier extends Classifier{

    public abstract void buildClassifier() throws Exception;

    public void buildClassifier(Instances dataset) throws Exception{
        throw new Exception("buildClassifier(Instances) is not defined\n");
    }

    public double accuracy(String[] options) throws Exception {
        String test_file = weka.core.Utils.getOption('T', options);
        BufferedReader in = new BufferedReader(new FileReader(test_file));
        Instances test_set = new Instances(in);
        test_set.setClassIndex(test_set.numAttributes()-1);
        in.close();
        setOptions(options);
        buildClassifier();
        int correct = 0;
        for(int i=0; i<test_set.numInstances(); i++){
            Instance tuple = test_set.instance(i);
            double label = classifyInstance(tuple);
            if(label == tuple.classValue()){
                correct++;
            }
        }
        return ((double)correct)/((double)test_set.numInstances());
    }

    public void printOptions(){
        System.out.print("Options:\n"+
                         "  -t <training file>\n"+
                         "  -T <test file>\n"+
                         "  -P (print the model(s))\n");
        Enumeration e = this.listOptions();
        while(e.hasMoreElements()){
            Option opt = (Option) e.nextElement();
            System.out.println("  "+opt.synopsis()+"\n"+opt.description());
        }
    }

}
