
package LFA2;

import java.io.*;
import weka.core.*;

public class Tool{

  public static void main(String [] argv) throws Exception {
    SchemaInfo schema = new SchemaInfo(argv[0], argv[1], 10, 1);
    String outputName = argv[2];
    String test_file = argv[3];
    String[] temp = outputName.split("/");
    String relname = temp[temp.length-1];
    PrintStream globalOut = new PrintStream(new FileOutputStream(outputName+".schema"));
    int[] min = new int[schema.numOfAttrs];
    int[] max = new int[schema.numOfAttrs];
    String[] name= new String[schema.numOfAttrs];
    int i, attrId;
    for(i=0; i<schema.numOfAttrs; i++){
        min[i]=100000; max[i]=-1000000; name[i]="";
    }
    for(int t=0; t<schema.numOfTables; t++){
      PrintStream out = new PrintStream(new FileOutputStream(outputName+"."+t));
      BufferedReader in = new BufferedReader(new FileReader(schema.baseSpecFile[t]));
      Instances data = new Instances(in);
      out.println("@relation "+relname+"."+t);
      for(i=0; i<data.numAttributes(); i++){
          Attribute attr = data.attribute(i);
          out.println("@attribute "+attr.name()+" integer");
          attrId = schema.globalAttrId[t][i];
          if(attrId>=0) name[attrId] = attr.name();
      }
      out.println("@data");
      for(i=0; i<data.numInstances(); i++){
          Instance tuple = data.instance(i);
          for(int j=0; j<tuple.numAttributes(); j++){
              if(j>0) out.print(",");
              int v = (int) tuple.value(j);
              out.print(v);
              attrId = schema.globalAttrId[t][j];
              if(attrId>=0){
                  if(max[attrId]<v) max[attrId]=v;
                  if(min[attrId]>v) min[attrId]=v;
              }
          }
          out.println("");
      }
      out.close();
      data = null;
    }
    globalOut.print("@schema ");
    TableSpec globalSpec = schema.globalSpec;
    for(i=0; i<globalSpec.numAttributes(); i++){
        if(i>0) globalOut.print(",");
        Attribute attr = globalSpec.attribute(i);
        globalOut.print(attr.name());
    }
    for(int t=0; t<schema.numOfTables; t++){
        globalOut.println("\n@relation "+relname+"."+t+" % "+relname+"."+t+", 100, 100");
        for(i=0; i<schema.globalAttrId[t].length; i++){
            attrId = schema.globalAttrId[t][i];
            if(attrId>=0)
                globalOut.println("@attribute "+name[attrId]+" integer % "+min[attrId]+", "+max[attrId]+", "+(max[attrId]-min[attrId]+1));
            else
                globalOut.println("@attribute __LFACount__ integer");
        }
    }
    globalOut.close();
    
    PrintStream out = new PrintStream(new FileOutputStream(outputName+".test"));
    BufferedReader in = new BufferedReader(new FileReader(test_file));
    Instances data = new Instances(in);
    out.println("@relation "+relname);
    for(i=0; i<data.numAttributes(); i++){
        Attribute attr = data.attribute(i);
        out.println("@attribute "+attr.name()+" integer");
    }
    out.println("@data");
    for(i=0; i<data.numInstances(); i++){
        Instance tuple = data.instance(i);
        for(int j=0; j<tuple.numAttributes(); j++){
            if(j>0) out.print(",");
            int v = (int) tuple.value(j);
            out.print(v);
        }
        out.println("");
    }
    out.close();
  }

}
